package workforecast

class AdminController {
    
    def roles = ["Consultant", "Manager", "Controller", "Resourcing", "Director"]
    
    def authenticateUser(roleName)
    {
        if(!session.user)
            return false
        else
        {
            def curUser = User.get(session.user.id[0])
            if(curUser.role == roleName)
            return true
            else
            return false
        }
    }

    def index() 
    {
	if(!authenticateUser("Admin"))
            redirect(controller:"main", action:"index")
        else
            render(view: "index", model: [users:User.list(), roles:roles]) 
        
               
    }
    def deleteUser()
    {
        if(!authenticateUser("Admin"))
            redirect(controller:"main", action:"index")
                else
                {
                    def userID = params.id
                    def x = User.get(userID)
                    if(x.role!="Admin")
                    {
                        x.delete()
                    }
                    
                    redirect(view: "index", model: [users:User.list(), roles:roles])
                }
    }
    
    def editUser()
    {
        if(!authenticateUser("Admin"))
	{
		redirect(controller:"main", action:"index")
	}
	else
        {
                
                
                    //getting parameters
                    def userID = params.userID
                    def userName = params.userName
                    def password = params.password
                    def realName = params.realName
                    def roleName = params.roleName
                    def employmentYear = params.int("employmentYear")
                    
                    println params
                    
                    //trying to obtain a user
                    def curUser = User.get(userID)
                    if(!curUser)  //creation
                    {
                        curUser = new User()
                        curUser.username = userName
                        curUser.password = password
                        curUser.realname = realName
                        curUser.role = roleName
                        curUser.employmentYear = employmentYear
                        
                        if(!curUser.save())
                        println curUser.errors
                
                        if(roleName=="Consultant")//if new user is consultant
                        {
                            //adding 2-type activities
                            def salesActivity = new Activity()
                            salesActivity.a_name="Sales"
                            salesActivity.a_type=3
                            salesActivity.user=curUser
                            
                            def ldActivity = new Activity()
                            ldActivity.a_name="L&D"
                            ldActivity.a_type=3
                            ldActivity.user=curUser
                            
                            def iwActivity = new Activity()
                            iwActivity.a_name="Internal work"
                            iwActivity.a_type=3
                            iwActivity.user=curUser
                            
                            def illActivity = new Activity()
                            illActivity.a_name="Illness"
                            illActivity.a_type=3
                            illActivity.user=curUser
                            
                            def plActivity = new Activity()
                            plActivity.a_name="Paid leave"
                            plActivity.a_type=3
                            plActivity.user=curUser
                            
                            def absActivity = new Activity()
                            absActivity.a_name="Non-paid absence"
                            absActivity.a_type=3
                            absActivity.user=curUser
                            
                            def vacActivity = new Activity()
                            vacActivity.a_name="Vacation"
                            vacActivity.a_type=3
                            vacActivity.user=curUser
                            
                            if(!salesActivity.save())
                                println salesActivity.errors
                                
                            if(!ldActivity.save())
                                println ldActivity.errors
                                
                            if(!iwActivity.save())
                                println iwActivity.errors
                                    
                            if(!illActivity.save())
                                println illActivity.errors
                                
                            if(!plActivity.save())
                                println plActivity.errors
                                
                            if(!absActivity.save())
                                println absActivity.errors
                                
                            if(!vacActivity.save())
                                println vacActivity.errors
                            
                            
                        }
                    }
                    else  //updating
                    {
                        curUser.username = userName
                        curUser.password = password
                        curUser.realname = realName
                        if(curUser.role!="Admin")
                        {
                            curUser.role = roleName
                            curUser.employmentYear = employmentYear
                        }
                        
                        if(!curUser.save())
                        println curUser.errors
                    }
                    
                    
                    
                    
                    
                    redirect(view: "index", model: [users:User.list(), roles:roles])
                
        }
    }
}
