package workforecast

import java.util.Calendar;

class ConsultantCabinetController {
	
        
    def authenticateUser(roleName)
    {
        if(!session.user)
            return false
        else
        {
            def curUser = User.get(session.user.id[0])
            if(curUser.role == roleName)
            return true
            else
            return false
        }
    }
    
    

    def index = { 
                println session.user
		if(!authenticateUser("Consultant"))
		{
			redirect(controller:"main", action:"index")
			//return
		}
		else
                {
                        def curUser = User.get(session.user.id[0])
                        def activities1 = Activity.findAllByUserAndA_typeBetween(curUser,1,2)
                        def activities2 = Activity.findAllByUserAndA_type(curUser,3)
                        def messages = Message.findAllByMessageAddressee(curUser)
			render(view: "index", model: [activities:activities1, activities2:activities2, messages:messages])
                }
                    
        }
	
        //apply changes or creates new activity
        def saveActivity()
        {
            if(!authenticateUser("Consultant") && !authenticateUser("Manager"))
		{
			redirect(controller:"main", action:"index")
			//return
		}
            else
                {
                    println params
                    
                    def newActivity = Activity.get(params.int("activityID"))
                    if(!newActivity)
                    {
                        newActivity = new Activity()
                        newActivity.user=User.get(params.int("userID"))
                    }
                    
            
                    newActivity.a_name = params.inputName
                    newActivity.a_client = params.inputClient
                    newActivity.a_description = params.inputDescription
                    newActivity.a_probability = params.int('inputProbability')
                    newActivity.a_costperhour = params.int('inputCOR')
                    newActivity.a_type = params.int('activityType')
                    
            
                    if(!newActivity.save())
                        println newActivity.errors
                
                    def curUser = User.get(params.int("userID"))
            
                    render(view:"activityLine", model:[activity:newActivity])
                }
        }
        
        //deletes existing activity
        def deleteActivity()
        {
            if(!authenticateUser("Consultant")&&!authenticateUser("Manager"))
		{
			redirect(controller:"main", action:"index")
			//return
		}
		else
                {
                    def index = params.int("id")
                    def A=Activity.get(index)
                    def U = A.user
            
                    U.removeFromActivities(A)
            
                    if(!A.delete())
                    {
                        println A.errors
                    }
            
                    if(!U.save())
                    {
                        println U.errors
                    }
                    
                    render("")
                }
        }
        
        //renders activity edit panel
        def activityEditPage()
        {
            if(!authenticateUser("Consultant")&&!authenticateUser("Manager"))
		{
			redirect(controller:"main", action:"index")
			//return
		}
		else
                {
                    render(view:"activityEditPage")
                }
        }
    
    //single activity forecast
    def showActivityForecast()
    {
        if(!authenticateUser("Consultant")&&!authenticateUser("Manager"))
	{
            redirect(controller:"main", action:"index")
            return
	}
        //input parameters
        def activityID = params.activityID
        def year = params.int("year")
        
        //getting activity
        def A = Activity.get(activityID)
        
        def Calendar newCalendar = new GregorianCalendar(year,01,01)
        
        //we will display weeks in sections, grouped by 6 items. Here we obtain the number
        //of weeks and the number of full groups
        def WeekCount = Math.floor(newCalendar.getActualMaximum(Calendar.WEEK_OF_YEAR))
        def Spaces = Math.floor(WeekCount/6)
        
        
        //assigning month name for a week. Not implemented yet
        def Months = new ArrayList()
        
        for(def i=0;i<WeekCount;i++)
        Months.add("Month")
        
        //creating empty data for table cells
        def String[] cellData = new String[WeekCount]
        for(def i=0;i<WeekCount;i++)
            cellData[i]=""
        
        //Here we are obtaining forecast data for all weeks in the year
        def Weeks = Week.findAllByWeekYearAndActivity(year,A)
        Weeks.each{week->cellData[week.weekNumber-1]=week.weekPercentage}
        
        
        
        render(view:"activityForecast", model:[activity:A, year:year, months:Months, weekcount:WeekCount, spaces:Spaces,celldata:cellData, employmentYear:session.user.employmentYear])
    }
    
    //saves the forecast data and reloades the page in the case if another year was selected
    def editActivityForecast()
    {
        if(!authenticateUser("Consultant")&&!authenticateUser("Manager"))
        {
            redirect(controller:"main", action:"index")
            return
	}
        //getting parameters
        def activityID = params.int("activityID")
        def currYear = params.int("currYear")
        def nextYear = params.int("nextYear")
        def currWeekCount = Integer.parseInt(params.currWeekCount)
        def A = Activity.get(activityID)
        
        println params
        println currWeekCount
        
        //updating activity data
        for(def i=1;i<=currWeekCount;i++)
        {
            def value = params.int("week"+(i))
            //println value
            if(value)
            {
                def W = Week.findByWeekYearAndWeekNumberAndActivity(currYear,i,A)
                if(!W)
                {
                    W = new Week()
                    W.activity = A
                    W.weekNumber = i
                }
                W.weekPercentage = value
                W.weekYear = currYear
                if(!W.save())
                println W.errors
            }//if value
            else
            {
                def W = Week.findByWeekYearAndWeekNumberAndActivity(currYear,i,A)
                if(W)
                {
                    A.removeFromWeeks(W)
                    if(!W.delete())
                    println W.errors
                    A.save()
                }
            }
        }//for
        
        //showing page again
        redirect(controller:"consultantCabinet", action:"showActivityForecast", params:[activityID:A.id, year:nextYear])
        
    }
    
    //shows the full forecast for a current user, year and month
    def showFullForecast()
    {
        def userID = params.int("userID")
        def currYear = params.int("year")
        def currMonth = params.int("month")//0=January, 1=February, ...
        
        def readOnly
        if(params.readOnly)
        readOnly=true
        
        def currUser = User.get(userID)
        
        println params
        
        //First, let's get the weeks in current month and number of working days in weeks
        def Weeks = new ArrayList()
        def WorkingDays = new ArrayList()
        
        def c1 = Calendar.getInstance()
        
        if(currMonth==0)//January
        {
            c1.set(Calendar.YEAR,currYear)
            c1.set(Calendar.MONTH,0)
            //c1.set(Calendar.WEEK_OF_YEAR,1)
        }
        else //other month
        {
            c1 = new GregorianCalendar(currYear,currMonth,1)
        }
        
        //Now, let's count...
        
        def N = c1.get(Calendar.WEEK_OF_YEAR)
        def WD = 0
        def daysCount=0 //total number of days
        
        println c1.get(Calendar.MONTH)
        
        while(c1.get(Calendar.MONTH)==currMonth)
        {
            if(c1.get(Calendar.WEEK_OF_YEAR)!=N)//Next week has started
            {
                if(WD>0)
                {
                    if(N==54)
                      break;
                    Weeks.add(N)
                    WorkingDays.add(WD)
                    daysCount+=WD
                }
                N++
                WD=0
            }
            
            def z = c1.get(Calendar.DAY_OF_WEEK)
            if((z!=Calendar.SATURDAY)&&(z!=Calendar.SUNDAY))//working day
                WD++
            
            c1.add(Calendar.DAY_OF_MONTH,1)
            
        }
        
        if(WD>0)
        {
            if(N!=54)
            {
            Weeks.add(N)
            WorkingDays.add(WD)
            daysCount+=WD
            }
        }
        
        def M = Weeks.count{x->true}
        
        //getting all Activities, which has records, belonging to this period
        def Activities = currUser.activities
        
        def Records1 = new ArrayList()
        def Records2 = new ArrayList()
        
        //Variables for calculated values
        
        def totalTime=0
        def totalOverrun=0
        def totalRevenue=0
        
        Activities.each
        {
            a->
            def currWeeks = Week.where{activity==a && weekNumber>=Weeks.first() && weekNumber<=Weeks.last() && weekYear==currYear}.findAll()
            def weeksData = new String[M]
                for(def i=0;i<M;i++)
                    weeksData[i]=""
                
            def localTime=0
            def localRevenue=0
            
            if(currWeeks)
            {
                
                
                currWeeks.each
                {
                    week->
                    weeksData[week.weekNumber-Weeks.first()]=(week.weekPercentage)
                    
                    localTime+=(week.weekPercentage/100)*WorkingDays.getAt(week.weekNumber-Weeks.first())
                    localRevenue+=7*WorkingDays.getAt(week.weekNumber-Weeks.first())*(week.weekPercentage/100)*a.a_costperhour
                    
                }
            }//if currWeeks
                
                if(a.a_type!=3)
                {
                    if(a.a_type==1)//billable
                    {
                        totalTime+= localTime
                    }
                    else//overrun
                    {
                        totalTime+= localTime
                        totalOverrun+=localTime
                        localRevenue=0
                    }
                    
                    Records1.add([a.id, a.a_name, a.a_client, a.a_description, a.a_probability, a.a_costperhour, weeksData, localTime, localRevenue/100])
                    totalRevenue+=localRevenue
                }
                else
                {
                    Records2.add([a.id, a.a_name, a.a_client, a.a_description, a.a_probability, a.a_costperhour, weeksData, localTime])
                }
            
            
        }//Activities each
        
        println daysCount
        
        def ARVE = (totalTime/daysCount)*100
        def URVE = ((totalTime - totalOverrun)/daysCount)*100
        
        def COR = 0
        if(totalTime!=totalOverrun)
         COR=(totalRevenue/(totalTime-totalOverrun))/10
        
        
        
        
        render(view:"fullForecast", model:[month:currMonth, year:currYear, weeks:Weeks, workingdays:WorkingDays, activities1:Records1, activities2:Records2, weekcount:M, arve:ARVE, urve:URVE, cor:COR, user:currUser, readOnly:readOnly])
        
        
    }//showFullForecast
    
    def saveFullForecast()
    {
        def Activities = params.activityID
        def Weeks = params.weekNumber
        def nextYear = params.int("nextYear")
        def nextMonth = params.int("nextMonth")
        def userID = params.int("userID")
        def readOnly = params.readOnly
        
        def currYear = params.int("currYear")
        
        println params
        
        if((Activities)&&(!readOnly))
        {
         
        
        def N = Activities.count{t->true}
        def M = Weeks.count{t->true}
        
        for(def i=0;i<N;i++)//updating data
        {
            for(def j=0;j<M;j++)
                {
                    def currValue = params.int("input_"+Activities[i]+"_"+Weeks[j])
                    if(currValue)
                    {
                        def currAct = Activity.get(Activities[i])
                        def currWeek = Week.where{activity==currAct && weekNumber==Integer.parseInt(Weeks[j]) && weekYear==currYear}.find()
                        if(!currWeek)
                        {
                            currWeek = new Week()
                            currWeek.activity=currAct
                            currWeek.weekYear=currYear
                            currWeek.weekNumber =Integer.parseInt(Weeks[j])
                        }
                        currWeek.weekPercentage = currValue
                        if(!currWeek.save())
                            println currWeek.errors
                    }
                    else
                    {
                        def currAct = Activity.get(Activities[i])
                        def currWeek = Week.where{activity==currAct && weekNumber==Integer.parseInt(Weeks[j]) && weekYear==currYear}.find()
                        if(currWeek)
                        {
                            currAct.removeFromWeeks(currWeek)
                            if(!currWeek.delete())
                                println currWeek.errors
                            currAct.save()
                        }
                    }
                    
                }//for
        }//for
        
        }//if
        
        redirect(controller:"consultantCabinet", action:"showFullForecast", params:[year:nextYear, month:nextMonth, userID:userID, readOnly:readOnly])
    
    }
    
    
	

}
